﻿Imports System.Drawing.Drawing2D

Public Class Form1
    ' Redraw on resize.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.ResizeRedraw = True
    End Sub

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        ' Make things smoother.
        e.Graphics.SmoothingMode = SmoothingMode.AntiAlias

        ' Create the text path.
        Dim path As New GraphicsPath(FillMode.Alternate)

        ' Draw text using a StringFormat to center it on the form.
        Using font_family As FontFamily = New FontFamily("Times New Roman")
            Using sf As New StringFormat()
                sf.Alignment = StringAlignment.Center
                sf.LineAlignment = StringAlignment.Center
                path.AddString("Text", font_family, _
                    CInt(FontStyle.Bold), 200, _
                    Me.ClientRectangle, sf)
            End Using
        End Using

        ' Make a bitmap containing the brush's text.
        Using small_font As New Font("Times New Roman", 8)
            ' See how big the text will be.
            Dim text_size As SizeF = e.Graphics.MeasureString("Text", small_font)

            ' Make a Bitmap to hold the text.
            Dim bm As New Bitmap( _
                CInt(2 * text_size.Width), _
                CInt(2 * text_size.Height))
            Using gr As Graphics = Graphics.FromImage(bm)
                gr.Clear(Color.LightBlue)
                gr.DrawString("Text", small_font, Brushes.Red, 0, 0)
                gr.DrawString("Text", small_font, Brushes.Green, text_size.Width, 0)
                gr.DrawString("Text", small_font, Brushes.Blue, -text_size.Width / 2, text_size.Height)
                gr.DrawString("Text", small_font, Brushes.DarkOrange, text_size.Width / 2, text_size.Height)
                gr.DrawString("Text", small_font, Brushes.Blue, 1.5F * text_size.Width, text_size.Height)

                ' Fill the path with the brush.
                Using br As New TextureBrush(bm)
                    e.Graphics.FillPath(br, path)
                End Using
            End Using

            ' Outline the path.
            Using pen As New Pen(Color.Black, 3)
                e.Graphics.DrawPath(pen, path)
            End Using
        End Using
    End Sub
End Class
